/* Problem URL: https://codeforces.com/gym/101908/problem/L */

#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vvi graph(n);

    rep(i, n - 1) {
        int a, b;
        cin >> a >> b;
        a--, b--;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    vvi parent(n, vi(20, 0));
    vi depth(n, 0);

    function<void(int, int)> dfs = [&](int i, int p) {
        depth[i] = depth[p] + 1;
        parent[i][0] = p;

        nrep(j, 1, 20) {
            parent[i][j] = parent[parent[i][j - 1]][j - 1];
        }

        for (auto j : graph[i]) {
            if (j == p) {
                continue;
            }

            dfs(j, i);
        }
    };

    dfs(0, 0);

    auto lca = [&](int a, int b) {
        if (depth[a] > depth[b]) {
            swap(a, b);
        }

        int diff = depth[b] - depth[a];

        rep(i, 20) {
            if ((diff >> i) & 1) {
                b = parent[b][i];
            }
        }

        if (a == b) {
            return a;
        }

        for (int i = 19; i >= 0; i--) {
            if (parent[a][i] != parent[b][i]) {
                a = parent[a][i];
                b = parent[b][i];
            }
        }

        return parent[a][0];
    };

    auto dis = [&](int a, int b) {
        return depth[a] + depth[b] - 2 * depth[lca(a, b)];
    };

    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;

        int x = dis(a, b) + dis(c, d);
        int y = min(dis(a, c) + dis(b, d), dis(a, d) + dis(b, c));

        if (y > x) {
            cout << "0\n";
            continue;
        }

        cout << (x - y) / 2 + 1 << '\n';
    }
}
